
///////////////////////////////////////////////////////////////////////
// Module 	: TP CORBA JAVA
// Composant 	: Client.java
// Creation 	: 09/03/1999
//
// Commentaires :  Code d'un client java invoquant un objet CORBA
// MOD1		:
///////////////////////////////////////////////////////////////////////
// $Id: Client.java,v 1.1 1999/03/10 14:11:08 singhoff Exp singhoff $
///////////////////////////////////////////////////////////////////////

package tpcorba;


import org.omg.CORBA.*;
import java.lang.*;
import java.util.*;
import java.io.*;



public class Client
	{


	public static void main(String args[]) throws IOException
		{ 


		////////////////////////////////////////////////////
		// On initialise l'ORB
		////////////////////////////////////////////////////

		Properties props = System.getProperties();
		props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
		props.put("org.omg.CORBA.ORBSingletonClass",
			"com.ooc.CORBA.ORBSingleton");
		System.setProperties(props);

		ORB orb = ORB.init(args, props);



		if(args.length!=1)
			{
			System.err.println("utilisation : Client nombre");
			System.exit(1);
			}


		////////////////////////////////////////////////////
		// Recuperation de la reference d'objet du serveur
		// Dans cet exemple, la reference est stockee sous
		// la forme d'une chaine de caractere (IOR) dans un
		// fichier. A ce stade, il est bien sur possible 
		// d'invoquer un service de nommage.
		////////////////////////////////////////////////////
      
		String ior = null;
		try
			{
			String ref = "calcul.ref";
			FileInputStream file = new FileInputStream(ref);
			BufferedReader in = new BufferedReader(new InputStreamReader(file));
			ior = in.readLine();
			file.close();
			}
		catch(IOException ex)
			{
			System.err.println("Impossible de lire fichier : `" +
				ex.getMessage() + "'");
			System.exit(1);
			}
      

		////////////////////////////////////////////////////
		// Construction d'une reference d'objet, non type d'abord,
		// puis "converti" en une reference sur l'interface 
		// "calcul"  avec le narrow (operation de "cast" dynamique)
		////////////////////////////////////////////////////
	
		org.omg.CORBA.Object obj = orb.string_to_object(ior);
		if(obj==null)
			{
			System.err.println("Erreur sur string_to_object() ");
			throw new RuntimeException();
			}
      

		tpcorba.calcul calc = tpcorba.calculHelper.narrow(obj);
		if(calc==null)
			{
			System.err.println("Erreur sur narrow() ");
			throw new RuntimeException();
			}


		////////////////////////////////////////////////////
		// Invocation du serveur
		////////////////////////////////////////////////////

		char car;

		Integer Param = new Integer(args[0]);

		IntHolder Resultat = new IntHolder(Param.intValue());

      		try
			{
	      		System.out.println(" Que faire (racine ou carre)?  ");
	      		car = (char)System.in.read();
	      
	      		if (car == 'c')  
				{
				calc.bid_carre(Resultat);

				System.out.println(" Le carre de " + Param.intValue() + " vaut : " + Resultat.value);
				}  
			else	if (car == 'r')
                        		{
                        		calc.bid_rac(Resultat);

					System.out.println(" La racine de " + Param.intValue() +" vaut : " + Resultat.value);
                        		}
			else System.out.println("  Saisir 'r' ou 'c'");
			
			}
      		catch(IOException ex)
			{
			System.out.println("Erreur lecture commande (char)");
			System.exit(1);
			}


		System.exit(0);
		}
}

