
///////////////////////////////////////////////////////////////////////
// Module       : TP CORBA 1999
// Composant    : Serveur.java
// Creation     : 09/03/1999
//
// Commentaires :  Code d'un serveur exportant un objet CORBA (voir
//		   tpcorba.idl)
// MOD1         :
///////////////////////////////////////////////////////////////////////
// $Id: Serveur.java,v 1.1 1999/03/12 14:29:48 singhoff Exp singhoff $
///////////////////////////////////////////////////////////////////////


package tpcorba;

import org.omg.CORBA.*;
import java.util.*;
import java.io.*;
import java.lang.*;

public class Serveur 
	{
	public static void main(String args[]) throws IOException
		{ 

                ////////////////////////////////////////
                // Initialisation de l'ORB et de la BOA 
                ////////////////////////////////////////



		Properties props = System.getProperties();
		props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
		props.put("org.omg.CORBA.ORBSingletonClass",
			"com.ooc.CORBA.ORBSingleton");
		System.setProperties(props);


		ORB orb = ORB.init(args, props);
		BOA boa = ((com.ooc.CORBA.ORB)orb).BOA_init(args, props);


                if(args.length!=1)
                        {
                        System.err.println("utilisation : Serveur nb-objets-max ");
                        System.exit(1);
                        }




		////////////////////////////////////////////////////////////////
		// Instantiation de l'objet : creation de 
		//	l'implantation de l'objet
		////////////////////////////////////////////////////////////////
	  
                Integer Param = new Integer(args[0]);

		usine_Impl usine = new usine_Impl(boa,Param.intValue());
      		try
			{
	  		String usine_ref = orb.object_to_string(usine);
	  		String refFile = "usine.ref";
	  		PrintWriter out = new PrintWriter(new FileOutputStream(refFile));
	  		out.println(usine_ref);
	  		out.close();
			}
      		catch(IOException ex)
			{
	  		System.err.println("Impossible d'ecrire la reference dans usine.ref");
	  		System.exit(1);
			}


		////////////////////////////////////////////////////////////////
		// Activation de l'objet
		////////////////////////////////////////////////////////////////
			
		boa.obj_is_ready(usine,null);



		////////////////////////////////////////////////////////////////
		// Lancement de la BOA : par partir de cet instant, le serveur
		// est capable de traiter les requetes sur les objets deja
		// actives ainsi que ceux qui le seront par la suite
		// La methode "impl_is_ready" est bloquante
		////////////////////////////////////////////////////////////////

		System.out.println("Le serveur est pret ");

  		boa.impl_is_ready(null);
      
	  
		System.exit(0);
		}


	}


